import { Prop, SetupContext, VNodeChild, VNodeProps } from 'vue';
import { Hanlder } from '@/type';
export declare abstract class VueComponent<T = Record<string, any>> {
    static handler: Hanlder[];
    static resolveComponent: any;
    static __vccOpts__value: any;
    static get __vccOpts(): any;
    /**
     * 主要给jsx提示用
     */
    get $props(): T & VNodeProps & Record<string, any>;
    /**
     * 组件属性
     */
    props: T & VNodeProps & Record<string, any>;
    /**
     * 组件上下文
     */
    context: SetupContext;
    constructor();
    /**
     * 渲染函数
     */
    abstract render(): VNodeChild;
    abstract render(ctx?: any): VNodeChild;
    abstract render(ctx?: any, cache?: any[]): VNodeChild;
}
export declare type ComponentProps<T extends Record<string, any>> = {
    [U in keyof T]-?: Prop<any>;
};
